package com.lilosoft.complex.matter.service;


import com.lilosoft.complex.IComplexService;
import com.lilosoft.complex.Rest;
import com.lilosoft.complex.matter.model.req.AcceptReq;
import com.lilosoft.complex.matter.model.req.ImplementationReq;
import com.lilosoft.complex.matter.model.req.DeviceLoginReq;
import com.lilosoft.complex.matter.model.rsp.AcceptRspInfo;
import com.lilosoft.complex.matter.model.rsp.LoginRspInfo;
import com.lilosoft.complex.matter.model.rsp.MatterListInfo;
import com.lilosoft.complex.matter.model.rsp.MatterRespInfo;
import com.lilosoft.complex.matter.model.rsp.matter.MatterWorkInfo;
import com.lilosoft.complex.matter.model.rsp.work.WorkInfo;

import java.util.List;

/**
 * 综合窗口业务处理类
 *
 * @author: zxfei
 * @date: 2023/10/30 14:52
 */
public interface IComplexMatterService extends IComplexService {

    /**
     * 自助设备登录
     *
     * @param deviceLoginReq
     * @return
     */
    Rest<LoginRspInfo> deviceLogin(DeviceLoginReq deviceLoginReq);

    /**
     * 附件上传
     *
     * @param bytes
     * @param fileName
     * @return
     */
    Rest<String> uploadFile(String deviceLogo,byte[] bytes, String fileName);


    /**
     * 自助设备接件
     *
     * @param acceptReq
     * @return
     */
    Rest<List<AcceptRspInfo>> accept(String deviceLogo,AcceptReq acceptReq);

    /**
     * 查询可受理事项
     *
     * @param implementationReq
     * @return
     */
    Rest<MatterListInfo> findMatters(String deviceLogo, ImplementationReq implementationReq);


    /**
     * 查询办理事项情形
     *
     * @param eventIds
     * @return
     */
    Rest<MatterWorkInfo> doWorkMatterSearch(String deviceLogo, String eventIds);


    /**
     * 获取办件要素
     * @param deviceLogo
     * @param eventIds
     * @return
     */
    Rest<WorkInfo> getWorkMatter(String deviceLogo, String eventIds);



}
